#include "monopoly2.h"
#include<iostream>
#include<vector>
using namespace std;

int n;

vector<int> prep(int idx, int val){
	vector<int> ret;
	for(int i = 1; i <= n; i ++){
		if(i == val) continue;
		ret.push_back(i);
	}
	ret.insert(ret.begin() + (idx - 1), val);
	return ret;
}

bool ok(int idx, int val){
	auto t = prep(idx, val);
	auto b = check(t);
	// for(auto x : t) cout << x << " "; cout << endl;
	// for(auto x : b) cout << x << " "; cout << endl;
	int ret = 0;
	for(auto x : b) ret = max((int)x, (int)ret);
	return 1 - ret;
}

vector<pair<int, int>> find_connections(int N) {
	n = N;
	vector<pair<int, int>> edges;
	
	for(int leaf = n; leaf >= 2; leaf --){
		int low = 1, high = leaf, par = -1;
		// cout << "leaf = " << leaf << endl;
		while(low <= high){
			int mid = (low + high) / 2;
			bool flag = ok(mid, leaf);
			// cout << "flag = " << flag << endl;
			if(flag){
				par = mid - 1;
				high = mid - 1;
			}
			else{
				low = mid + 1;
			}
		}
		edges.push_back({par, leaf});
	}
	
	return edges;
}
