#include "monopoly2.h"
#include <iostream>
#include <vector>
#include <bits/stdc++.h>
#include <queue>
using namespace std;
vector<pair<int, int>> ans;
const int maxn = 1005;
vector<int> subtree[maxn];
int parent[maxn];
queue<int> active;
bool taken[maxn];
pair<int, int> possible[maxn];
void print_debug(int N)
{
    cout << "parents" << endl;
    for (int i = 1; i <= N; i++)
    {
        cout << i << " " << parent[i] << endl;
    }
    cout << "subtree" << endl;
    for (int i = 1; i <= N; i++)
    {
        cout << i << " : ";
        for (auto v : subtree[i])
        {
            cout << v << " ";
        }
        cout << endl;
    }

}

int level[maxn];
vector <int> levels[maxn];
int find_levels(int N)
{
    int left = N - 1;
    level[1] = 1;
    levels[1].push_back(1);
    int k = 1;
    while (left > 0)
    {
        k++;
        vector <int> p;
        for (int i = 1; i <= N; i++)
        {
            if (level[i] != 0)
            {
                p.push_back(i);
            }
        }
        for (int i = N; i > 0; i--)
        {
            if (level[i] == 0)
            {
                p.push_back(i);
            }
        }
        vector<bool> result = check(p);
        for(int i = 0; i < result.size(); i++)
        {
            int u = p[i];
            if (result[i] == 0 && level[u] == 0)
            {
                level[u] = k;
                levels[k].push_back(u);
                //cout << "level " << u << " " << k << endl;
                left--;
            }
        }
       // break;
    }
    return k;

}
int from[maxn], to[maxn];
bool found[maxn];
void calc(int l, int N)
{
   // cout << "LEVEL " << l << endl;
    bool fl = false;
    for(auto u : levels[l])
    {
        from[u] = 0;
        to[u] = levels[l-1].size()-1;
       // cout << u << " ::: " << from[u] << " " << to[u] << endl;
        if (from[u] == to[u])
        {
            ans.push_back(make_pair(levels[l-1][from[u]], u));
            found[u] = true;
        }
        else
            fl = true;
    }
    while(fl)
    {
        fl = false;
        vector <int> q[maxn];
        for(auto u : levels[l])
        {
            int mid = (from[u] + to[u]) / 2;
            q[mid].push_back(u);
        }
        vector <int> p;
        for(int i = 1; i <= N; i++)
        {
            if(level[i] < l-1) p.push_back(i);
        }
        for(int i = 0; i < levels[l-1].size(); i++)
        {
            p.push_back(levels[l-1][i]);
            for(auto u : q[i])
            {
                p.push_back(u);
            }
        }
        for(int i = 1; i <= N; i++)
        {
            if(level[i] > l) p.push_back(i);
        }

        vector<bool> result = check(p);
        for(int i = 0; i < result.size(); i++)
        {
            int u = p[i];
            if (level[u] != l) continue;
            if (found[u] == true) continue;
            int mid = (from[u] + to[u]) / 2;
            if (result[i] == 0)
            {
                to[u] = mid;
            }
            else
            {
                from[u] = mid + 1;
            }
            if (from[u] == to[u])
            {
                ans.push_back(make_pair(levels[l-1][from[u]], u));
                found[u] = true;
            }
            else
            {
                fl = true;
            }
        }
    }


}
vector<pair<int, int>> find_connections(int N)
{
    if (N == 1) return ans;
    ans.push_back(make_pair(1, 2));
    if (N == 2) return ans;
    ans.clear();
    int maxl = find_levels(N);
    for (int i = 2; i <= maxl; i++) calc(i, N);
    return ans;
}
