/* the core program has three arguments:
   - first - state of checking with three possible values:
              = 0 - checks the solution file according the answer file
              = x>0 - generates solution file with name from the third argument using the x-th solution
   - second - name of the input file
   - third - name of the file to be checked or generated
   - fourth - name of the correct output file (optional - only for option 0) */
#include<iostream>
#include<iomanip>
#include<string>
#include<vector>
#include<math.h>
#include "checker_tgen.h"
using namespace std;


int main (int argc, char** argv) {
    ifstream inp,out,ans;
    vector <string> solutions={
        "monopoly2_n2",
        "monopoly2_nlog",
        "monopoly2_100p"
    };
    check_arguments(argc,argv,inp,out,ans,solutions,"");
    inp.close();
    ans.close();
    bool ok=false;
    for (int i=1; ;  i++) {
        int num;
        if (!(out >> num)) break;
        if (i!=1) cout << " ";
        cout << num ;
        if (i==2) ok=(num==0);
    }
    cout << endl ;
    if (ok==true) cout << "OK!";
    else cout << "Wrong answer!";
    /*string command="..\\checker\\checker "+string(argv[2])+" "+string(argv[4])+" "+string(argv[3]);
    system(command.c_str());*/
    cout << endl ;
    return 0;
}
