#include "monopoly2.h"
#include<iostream>
#include<vector>
#include<tuple>
using namespace std;
const int MAXN=1000;
bool used[MAXN+1];
vector <int> before[MAXN+1];
int inds[MAXN+1];
vector <pair <int, int> > find_connections (int n) {
    vector <int> curr={1};
    curr.reserve(n);
    used[1]=true;
    int prv=0;

    vector <pair <int, int> > ans;
    ans.reserve(n-1);
    vector <int> tmp;
    tmp.reserve(n);
    vector <tuple <int, int, int>> level;
    level.reserve(n);
    vector <int> rest;
    rest.reserve(n);

    for (;;) {
        if (curr.size()==n) break;
        rest.clear();
        level.clear();
        if (curr.size()<n-1) {
            tmp=curr;
            for (int i=n; i>=1; i--) {
                if (used[i]==true) continue;
                tmp.push_back(i);
            }
            auto b=check(tmp);
            for (int i=0; i<n; i++) {
                if (used[tmp[i]]==true) continue;
                if (b[i]==true) {
                    rest.push_back(tmp[i]);
                    continue;
                }
                level.push_back({tmp[i], 0, curr.size()});
            }
        }
        else {
            for (int i=n; i>=1; i--) {
                if (used[i]==false) {
                    level.push_back({i, 0, curr.size()});
                    break;
                }
            }
        }
        for (;;) {
            bool finished=true;
            for (int i=0; i<level.size(); i++) {
                auto [v, l, r]=level[i];
                if (l!=r-1) {
                    finished=false;
                    break;
                }
            }
            if (finished==true) break;

            for (int i=0; i<level.size(); i++) {
                auto [v, l, r]=level[i];
                before[(l+r)/2].push_back(v);
            }
            tmp.clear();
            for (int i=0; i<curr.size(); i++) {
                for (auto v : before[i]) {
                    inds[v]=tmp.size();
                    tmp.push_back(v);
                }
                before[i].clear();
                tmp.push_back(curr[i]);
            }
            tmp.insert(tmp.end(),rest.begin(),rest.end());
            auto b=check(tmp);
            for (int i=0; i<level.size(); i++) {
                auto& [v, l, r]=level[i];
                if (l==r-1) continue;
                if (b[inds[v]]==false) r=(l+r)/2;
                else l=(l+r)/2;
            }
        }
        prv=curr.size();
        for (int i=0; i<level.size(); i++) {
            auto [v, l, r]=level[i];
            ans.push_back({curr[l], v});
            curr.push_back(v);
            used[v]=true;
        }
    }
    return ans;
}
