#include "monopoly2.h"
#include<iostream>
#include<vector>
#include<set>
using namespace std;

//#include "Lgrader.cpp"

int _n;
vector<pair<int, int>> edges;

bool pred(int i, int j)
{
    vector<int> q;
    int idx_i = 0;
    for (int k = 1; k <= _n; ++ k)
    {
        if (k == i) 
        {
            q.push_back(j);
            idx_i = q.size() - 1;
            q.push_back(i);
        }
        else if (k != j) q.push_back(k);
    }
    return check(q)[idx_i];
}


vector <pair <int, int> > find_connections (int N) {
    _n = N;
    
    for (int i = 2; i <= _n; ++ i)
    {
        int le = 1, ri = i - 1, res = 0;
        while (le <= ri)
        {
            int mid = (le + ri) / 2;
            if (pred(mid, i))
            {
                res = mid;
                le = mid + 1;
            }
            else
            {
                ri = mid - 1;
            }
        }
        edges.push_back({res, i});
    }

    return edges;
}

